$EVENT_BUS.subscribe(new EventHandler('WORK_USERS_CHANGED', handlerUsersSelected));
function handlerUsersSelected(event, args) {
    processUsers(args);
}

$EVENT_BUS.subscribe(new EventHandler('WORK_DIALOG_UPDATE', handlerUpdate));
function handlerUpdate(event, args) {
    var scriptTag = document.getElementById('workloadLable');
    var parentTag = scriptTag.parentNode;
    var html = parentTag.childNodes.item("workloadLable");
    var text = html.innerText || html.textContent;
    parentTag.style.marginTop = "10px";
    html.innerHTML = ''
}
function processUsers(users) {
    var scriptTag = document.scripts[document.scripts.length - 1];
    var parentTag = scriptTag.parentNode;
    parentTag.style.marginTop = "10px";
    var html = parentTag.childNodes.item("workloadLable");
    html.innerHTML = '';

    if (users.args != null) {
        ajaxUserWL(users.args);
    }
}
function filtreAr(ar){
    var result = [];
    for(var i = 0; i < ar.length; i++){
        var t = false;
        for (var j=0;j<result.length;j++){
            if (result[j].userId==ar[i].userId){
                t = true;
            }
        }
        if (t){
            continue;
        }else{
            result.push(ar[i])
        }
    }
    return result;
}
function ajaxUserWL(ar) {
    ar = filtreAr(ar);
    var req = [];
    for (var i = 0; i < ar.length; i++) {
        var r = {userID: ar[i].userId, startDate: getCurrentDateFormated(), finishDate: getCurrentDateFormated()};
        req.push(r);
    }

    jQuery.ajax({
        url: 'rest/person/workload/m',
        type: 'post',
        data: JSON.stringify(req),
        contentType: 'application/json',
        dataType: 'json',
        success: function (data) {
            res = [];
            for (var i = 0; i < ar.length; i++) {
                var user = data[ar[i].userId];
                if (user == null) {
                    continue;
                }
                for (var j = 0; j < user.length; j++) {
                    if (parseFloat(user[j].value) > 100) {
                        res.push(ar[i]);
                    }
                }
            }
            overloadUsers(res);
        }
    });

}
function overloadUsers(lastnames) {
    if (lastnames.length == 0) {
        setTextMsg('');
        return
    } else if (lastnames.length == 1) {
        var sorceMsg = 'Внимание! Пользователь USER-ID перегружен.';
    } else if (lastnames.length > 10) {
        var sorceMsg = 'Внимание! Пользователи USER-ID и ещё COUNT перегружены.';

    } else {
        var sorceMsg = 'Внимание! Пользователи USER-ID перегружены.';
    }
    sorceMsg = sorceMsg.replace('COUNT', (lastnames.length - 10).toString());
    var users = '';
    for (var i = 0; i < lastnames.length && i < 10; i++) {
        if (i > 0) {
            users = users + ", "
        }
        users = users + getShortName(lastnames[i]);
    }
    var resultMsg = sorceMsg.replace('USER-ID', users);
    setTextMsg(resultMsg);
}
function setTextMsg(msg) {
    var scriptTag = document.scripts[document.scripts.length - 1];
    var parentTag = scriptTag.parentNode;
    var html = parentTag.childNodes.item("workloadLable");
    parentTag.style.marginTop = "10px";
    html.innerHTML = msg
}
function getShortName(user) {
    var result = user.lastname;
    if (user.firstname != null && user.firstname.length > 0) {
        result = result + ' ' + user.firstname.substring(0, 1) + '.';
    }
    if (user.patronymic != null && user.patronymic.length > 0) {
        result = result + ' ' + user.patronymic.substring(0, 1) + '.';
    }
    return result;
}
function getCurrentDateFormated() {
    return new Date().toISOString().split('T')[0];
}
